-
Data Grids / Data Management
-
Data Grid
- Overview
-
Data Binding
-
Filtering
- Sorting
-
Editing
-
Grouping
-
Selection
- Focused Row
- Paging
-
Scrolling
-
Columns
-
Master-Detail
-
Data Summaries
-
Drag & Drop
-
Export to PDF
-
Export to Excel
- Appearance
-
Customization
- State Persistence
-
Adaptability
-
Keyboard Navigation
- Right-To-Left Support
-
Tree List
- Overview
-
Data Binding
-
Filtering
- Sorting
-
Editing
-
Selection
- Focused Row
- Paging
-
Columns
- Drag & Drop
- State Persistence
- Adaptability
-
Keyboard Navigation
-
Card View
-
Pivot Grid
- Overview
-
Data Binding
-
Field Management
-
Data Summaries
- Drill Down
- Filtering
-
Scrolling
-
Export to Excel
- Chart Integration
- Customization
- State Persistence
-
Filter Builder
-
-
Data Visualization
-
Charts
- Overview
-
Data Binding
-
Common Concepts
-
Axis
-
Aggregation
-
Tooltips
-
Selection
-
Customization
-
Zooming
-
Export
-
-
Area Charts
-
Bar Charts
- Bullet Charts
-
Doughnut Charts
-
Financial Charts
-
Funnel and Pyramid Charts
-
Line Charts
- Pareto Chart
-
Pie Charts
-
Point Charts
-
Polar and Radar Charts
-
Range Charts
- Sankey Chart
-
Sparkline Charts
-
Tree Map
-
Gauges
- Overview
-
Runtime update
-
Bar Gauge
-
Circular Gauge
-
Linear Gauge
-
Diagram
- Overview
-
Data Binding
-
Featured Shapes
-
Custom Shapes
-
Document Capabilities
-
User Interaction
- UI Customization
- Adaptability
-
-
Scheduling / Planning
-
Scheduler
- Overview
-
Data Binding
-
Views
-
Appointments
-
Timetable
- Editing
-
Grouping
- Virtual Scrolling
- Drag & Drop
-
Customization
- Adaptability
-
Gantt
- Overview
- Data Binding
-
Filtering
- Sorting
- Strip Lines
- Export to PDF
- Validation
-
Customization
-
-
Messaging
-
WYSIWYG Editor
-
Forms
-
Data Editors
- Overview
-
Common Concepts
-
Calendar
- Check Box
- Color Box
-
Date Box
-
Date Range Box
-
Number Box
- Radio Group
-
Range Selector
- Range Slider
- Slider
- Switch
- Text Area
- Text Box
-
Drop-Downs
- Autocomplete
-
Drop Down Box
-
Select Box
-
Tag Box
-
Lookup
-
Buttons
-
File Upload / File Management
-
File Manager
- Overview
-
File System Types
-
Customization
-
File Uploader
-
-
Popup and Notifications
-
Navigation
- Overview
- Accordion
-
Action Sheet
-
Context Menu
-
Menu
- Multi View
-
Drawer
-
Tab Panel
-
Tabs
-
Toolbar
-
Stepper
- Pagination
-
List
-
Tree View
- Right-to-Left Support
-
Layout
-
Interactive Wrappers
-
Sortable
- Resizable
-
-
Progress Indicators
-
Maps
- Overview
-
Map
-
Vector Map
-
Data Binding
- Multiple Layers
-
Markers
- Legend
-
Zooming and Panning
-
Customization
-
-
Localization
Related Demos:
Your search did not match any results.
JavaScript/jQuery Vector Map - Zooming and Centering
This demo shows the JavaScript VectorMap zooming and centering capabilities. The map contains several cities represented by dot markers. To identify a city, pause on its marker, and the name of the city will appear in a tooltip. Moreover, if you click the marker, the map will be zoomed and centered on it. In code it is performed by calling the center(centerCoordinates) and zoomFactor(zoomFactor) methods. A click on the «Reset» button restores default center coordinates and zoom factor.
Was this demo helpful?
Feel free to share demo-related thoughts here.
If you have technical questions, please create a support ticket in the DevExpress Support Center.
Thank you for the feedback!
If you have technical questions, please create a support ticket in the DevExpress Support Center.
Backend API
$(() => {
const map = $('#vector-map').dxVectorMap({
tooltip: {
enabled: true,
customizeTooltip(arg) {
if (arg.layer.type === 'marker') {
return { text: arg.attribute('name') };
}
return null;
},
},
onClick(e) {
if (e.target && e.target.layer.type === 'marker') {
e.component.center(e.target.coordinates());
e.component.zoomFactor(10);
}
},
bounds: [-180, 85, 180, -60],
layers: [{
dataSource: DevExpress.viz.map.sources.world,
hoverEnabled: false,
}, {
dataSource: markers,
}],
}).dxVectorMap('instance');
$('#reset').dxButton({
text: 'Reset',
onClick() {
map.center(null).zoomFactor(null);
},
});
});
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
<script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script>
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.1.3/css/dx.light.css" />
<script src="js/dx.all.js"></script>
<script src="https://cdn3.devexpress.com/jslib/25.1.3/js/vectormap-data/world.js"></script>
<script src="https://cdn3.devexpress.com/jslib/25.1.3/js/vectormap-data/africa.js"></script>
<script src="https://cdn3.devexpress.com/jslib/25.1.3/js/vectormap-data/canada.js"></script>
<script src="https://cdn3.devexpress.com/jslib/25.1.3/js/vectormap-data/eurasia.js"></script>
<script src="https://cdn3.devexpress.com/jslib/25.1.3/js/vectormap-data/europe.js"></script>
<script src="https://cdn3.devexpress.com/jslib/25.1.3/js/vectormap-data/usa.js"></script>
<script src="data.js"></script>
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="index.js"></script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="vector-map"></div>
<div id="reset"></div>
</div>
</body>
</html>
#vector-map {
height: 420px;
}
#reset {
margin: 10px 2px;
}
const markers = [
{
coordinates: [-0.1262, 51.5002],
attributes: {
name: 'London',
},
},
{
coordinates: [149.1286, -35.2820],
attributes: {
name: 'Canberra',
},
},
{
coordinates: [139.6823, 35.6785],
attributes: {
name: 'Tokyo',
},
},
{
coordinates: [-77.0241, 38.8921],
attributes: {
name: 'Washington',
},
},
{
coordinates: [-75.6794, 45.4214],
attributes: {
name: 'Ottawa',
},
},
{
coordinates: [37.617778, 55.751667],
attributes: {
name: 'Moscow',
},
},
{
coordinates: [116.4, 39.933333],
attributes: {
name: 'Beijing',
},
},
{
coordinates: [12.5, 41.9],
attributes: {
name: 'Rome',
},
},
{
coordinates: [23.716667, 38],
attributes: {
name: 'Athens',
},
},
{
coordinates: [2.333333, 48.833333],
attributes: {
name: 'Paris',
},
},
{
coordinates: [-3.683333, 40.4],
attributes: {
name: 'Madrid',
},
},
{
coordinates: [-47.866667, -15.798889],
attributes: {
name: 'Brasilia',
},
},
];

Backend API
<dx-vector-map
id="vector-map"
[bounds]="[-180, 85, 180, -60]"
(onClick)="markerClick($event)"
>
<dxo-vector-map-tooltip
[enabled]="true"
[customizeTooltip]="customizeTooltip"
></dxo-vector-map-tooltip>
<dxi-vector-map-layer
[dataSource]="worldMap"
[hoverEnabled]="false"
></dxi-vector-map-layer>
<dxi-vector-map-layer [dataSource]="markers"></dxi-vector-map-layer>
</dx-vector-map>
<dx-button id="reset" text="Reset" (onClick)="resetClick()"></dx-button>
import { bootstrapApplication } from '@angular/platform-browser';
import {
Component, ViewChild, enableProdMode, provideZoneChangeDetection,
} from '@angular/core';
import { DxButtonModule } from 'devextreme-angular';
import { DxVectorMapModule, DxVectorMapComponent, DxVectorMapTypes } from 'devextreme-angular/ui/vector-map';
import * as mapsData from 'devextreme-dist/js/vectormap-data/world.js';
import { Marker, Service } from './app.service';
if (!/localhost/.test(document.location.host)) {
enableProdMode();
}
let modulePrefix = '';
// @ts-ignore
if (window && window.config?.packageConfigPaths) {
modulePrefix = '/app';
}
@Component({
selector: 'demo-app',
providers: [Service],
templateUrl: `app/app.component.html`,
styleUrls: [`app/app.component.css`],
imports: [
DxVectorMapModule,
DxButtonModule,
],
})
export class AppComponent {
@ViewChild(DxVectorMapComponent, { static: false }) vectorMap: DxVectorMapComponent;
worldMap = mapsData.world;
markers: Marker[];
constructor(service: Service) {
this.markers = service.getMarkers();
}
customizeTooltip(arg) {
if (arg.layer.type === 'marker') {
return {
text: arg.attribute('name'),
};
}
return null;
}
markerClick(e: DxVectorMapTypes.ClickEvent) {
if (e.target?.layer.type === 'marker') {
e.component.center(e.target.coordinates());
e.component.zoomFactor(10);
}
}
resetClick() {
this.vectorMap.instance.center(null);
this.vectorMap.instance.zoomFactor(null);
}
}
bootstrapApplication(AppComponent, {
providers: [
provideZoneChangeDetection({ eventCoalescing: true, runCoalescing: true }),
],
});
::ng-deep #vector-map {
height: 420px;
display: block;
}
::ng-deep #reset {
margin: 10px 2px;
}
import { Injectable } from '@angular/core';
export class Attributes {
name: string;
}
export class Marker {
coordinates: number[];
attributes: Attributes;
}
const markers: Marker[] = [
{
coordinates: [-0.1262, 51.5002],
attributes: {
name: 'London',
},
},
{
coordinates: [149.1286, -35.2820],
attributes: {
name: 'Canberra',
},
},
{
coordinates: [139.6823, 35.6785],
attributes: {
name: 'Tokyo',
},
},
{
coordinates: [-77.0241, 38.8921],
attributes: {
name: 'Washington',
},
},
{
coordinates: [-75.6794, 45.4214],
attributes: {
name: 'Ottawa',
},
},
{
coordinates: [37.617778, 55.751667],
attributes: {
name: 'Moscow',
},
},
{
coordinates: [116.4, 39.933333],
attributes: {
name: 'Beijing',
},
},
{
coordinates: [12.5, 41.9],
attributes: {
name: 'Rome',
},
},
{
coordinates: [23.716667, 38],
attributes: {
name: 'Athens',
},
},
{
coordinates: [2.333333, 48.833333],
attributes: {
name: 'Paris',
},
},
{
coordinates: [-3.683333, 40.4],
attributes: {
name: 'Madrid',
},
},
{
coordinates: [-47.866667, -15.798889],
attributes: {
name: 'Brasilia',
},
},
];
@Injectable()
export class Service {
getMarkers(): Marker[] {
return markers;
}
}
// In real applications, you should not transpile code in the browser.
// You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
const componentNames = [
'accordion',
'action-sheet',
'autocomplete',
'bar-gauge',
'box',
'bullet',
'button-group',
'button',
'calendar',
'card-view',
'chart',
'chat',
'check-box',
'circular-gauge',
'color-box',
'context-menu',
'data-grid',
'date-box',
'date-range-box',
'defer-rendering',
'diagram',
'draggable',
'drawer',
'drop-down-box',
'drop-down-button',
'file-manager',
'file-uploader',
'filter-builder',
'form',
'funnel',
'gallery',
'gantt',
'html-editor',
'linear-gauge',
'list',
'load-indicator',
'load-panel',
'lookup',
'map',
'menu',
'multi-view',
'nested',
'number-box',
'pagination',
'pie-chart',
'pivot-grid-field-chooser',
'pivot-grid',
'polar-chart',
'popover',
'popup',
'progress-bar',
'radio-group',
'range-selector',
'range-slider',
'recurrence-editor',
'resizable',
'responsive-box',
'sankey',
'scheduler',
'scroll-view',
'select-box',
'slider',
'sortable',
'sparkline',
'speech-to-text',
'speed-dial-action',
'splitter',
'stepper',
'switch',
'tab-panel',
'tabs',
'tag-box',
'text-area',
'text-box',
'tile-view',
'toast',
'toolbar',
'tooltip',
'tree-list',
'tree-map',
'tree-view',
'validation-group',
'validation-summary',
'validator',
'vector-map',
];
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.ts': {
loader: 'demo-ts-loader',
},
'typescript': {
'exports': 'ts',
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
'devextreme-dist/js/vectormap-data/*': {
'esModule': true,
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'@angular/platform-browser-dynamic': {
'esModule': true,
},
'@angular/platform-browser': {
'esModule': true,
},
'@angular/core': {
'esModule': true,
},
'@angular/common': {
'esModule': true,
},
'@angular/common/http': {
'esModule': true,
},
'@angular/animations': {
'esModule': true,
},
'@angular/forms': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
},
paths: {
'project:': '../../../../',
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'demo-ts-loader': 'project:utils/demo-ts-loader.js',
'demo-ts-shared': 'project:utils/demo-ts-shared.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
/* @angular */
'@angular/compiler': 'bundles:@angular/compiler.umd.js',
'@angular/platform-browser-dynamic': 'bundles:@angular/platform-browser-dynamic.umd.js',
'@angular/core': 'bundles:@angular/core.umd.js',
'@angular/core/primitives/signals': 'bundles:@angular/core.primitives.signals.umd.js',
'@angular/core/primitives/di': 'bundles:@angular/core.primitives.di.umd.js',
'@angular/common': 'bundles:@angular/common.umd.js',
'@angular/common/http': 'bundles:@angular/common-http.umd.js',
'@angular/platform-browser': 'bundles:@angular/platform-browser.umd.js',
'@angular/platform-browser/animations': 'bundles:@angular/platform-browser.umd.js',
'@angular/forms': 'bundles:@angular/forms.umd.js',
/* devextreme */
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69',
/* devextreme-angular umd maps */
'devextreme-angular': 'bundles:devextreme-angular/devextreme-angular.umd.js',
'devextreme-angular/common/ai-integration': 'bundles:devextreme-angular/devextreme-angular-common-ai-integration.umd.js',
'devextreme-angular/core': 'bundles:devextreme-angular/devextreme-angular-core.umd.js',
'devextreme-angular/common/charts': 'bundles:devextreme-angular/devextreme-angular-common-charts.umd.js',
'devextreme-angular/common/core/animation': 'bundles:devextreme-angular/devextreme-angular-common-core-animation.umd.js',
'devextreme-angular/common/core/environment': 'bundles:devextreme-angular/devextreme-angular-common-core-environment.umd.js',
'devextreme-angular/common/core/events': 'bundles:devextreme-angular/devextreme-angular-common-core-events.umd.js',
'devextreme-angular/common/core/localization': 'bundles:devextreme-angular/devextreme-angular-common-core-localization.umd.js',
'devextreme-angular/common/core': 'bundles:devextreme-angular/devextreme-angular-common-core.umd.js',
'devextreme-angular/common/data/custom-store': 'bundles:devextreme-angular/devextreme-angular-common-data-custom-store.umd.js',
'devextreme-angular/common/data': 'bundles:devextreme-angular/devextreme-angular-common-data.umd.js',
'devextreme-angular/common/export/excel': 'bundles:devextreme-angular/devextreme-angular-common-export-excel.umd.js',
'devextreme-angular/common/export/pdf': 'bundles:devextreme-angular/devextreme-angular-common-export-pdf.umd.js',
'devextreme-angular/common/export': 'bundles:devextreme-angular/devextreme-angular-common-export.umd.js',
'devextreme-angular/common/grids': 'bundles:devextreme-angular/devextreme-angular-common-grids.umd.js',
'devextreme-angular/common': 'bundles:devextreme-angular/devextreme-angular-common.umd.js',
'devextreme-angular/http': 'bundles:devextreme-angular/devextreme-angular-http.umd.js',
'devextreme-angular/core/tokens': 'bundles:devextreme-angular/devextreme-angular-core-tokens.umd.js',
...componentNames.reduce((acc, name) => {
acc[`devextreme-angular/ui/${name}`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}.umd.js`;
acc[`devextreme-angular/ui/${name}/nested`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}-nested.umd.js`;
return acc;
}, {}),
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'tslib': 'npm:tslib/tslib.js',
'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js',
'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js',
'devextreme-dist/js/vectormap-data': '../../../../js/vectormap-data',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
'zone.js': 'npm:zone.js@0.16.2/bundles/zone.umd.js',
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
'rxjs': {
defaultExtension: 'js',
},
'rxjs/operators': {
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:rxjs@7.5.3/package.json',
'npm:rxjs@7.5.3/operators/package.json',
'npm:devexpress-diagram@2.2.29/package.json',
'npm:devexpress-gantt@4.1.69/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line no-console
// System.import('@angular/compiler').catch(console.error.bind(console));
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
},
"@angular/core": {
"version": "22.0.2"
},
"core-js": {
"version": "2.6.12"
},
"typescript": {
"version": "6.0.3"
},
"zone.js": {
"version": "0.16.2"
}
};
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.3/css/dx.light.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/zone.js@0.16.2/bundles/zone.umd.js"></script>
<script src="https://cdn.jsdelivr.net/npm/reflect-metadata@0.1.13/Reflect.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
<script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script>
<script src="config.js"></script>
<script>
System.import("app").catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>

DevExtreme v25.1 is now available.

Explore our newest features/capabilities and share your thoughts with us.

Your search did not match any results.

Vue Vector Map - Zooming and Centering

This demo shows the VectorMap zooming and centering capabilities. The map contains several cities represented by dot markers. To identify a city, pause on its marker, and the name of the city will appear in a tooltip. Moreover, if you click the marker, the map will be zoomed and centered on it. In code it is performed by calling the center(centerCoordinates) and zoomFactor(zoomFactor) methods. A click on the «Reset» button restores default center coordinates and zoom factor.

Backend API
<template> <div> <DxVectorMap id="vector-map" ref="vectorMap" :bounds="bounds" @click="markerClick" > <DxLayer :data-source="mapsWorld" :hover-enabled="false" /> <DxLayer :data-source="markers"/> <DxTooltip :enabled="true" :customize-tooltip="customizeTooltip" /> </DxVectorMap> <DxButton id="reset" text="Reset" @click="reset" /> </div> </template> <script setup lang="ts"> import { ref } from 'vue'; // @ts-ignore import * as mapsData from 'devextreme-dist/js/vectormap-data/world.js'; import { DxVectorMap, DxLayer, DxTooltip, type DxVectorMapTypes, } from 'devextreme-vue/vector-map'; import { DxButton, } from 'devextreme-vue/button'; import { markers } from './data.ts'; const mapsWorld = mapsData.world; const bounds = [-180, 85, 180, -60]; const vectorMap = ref(); function customizeTooltip(info: any) { if (info.layer.type === 'marker') { return { text: info.attribute('name') }; } return {}; } function markerClick(e: DxVectorMapTypes.ClickEvent) { if (e.target?.layer.type === 'marker') { e.component.center(e.target.coordinates()); e.component.zoomFactor(10); } } function reset() { const vectorMapInstance = vectorMap.value.instance; vectorMapInstance.center(null); vectorMapInstance.zoomFactor(null); } </script> <style> #vector-map { height: 420px; } #reset { margin: 10px 2px; } </style>
window.exports = window.exports || {}; window.config = { transpiler: 'plugin-babel', meta: { '*.vue': { loader: 'vue-loader', }, '*.ts': { loader: 'demo-ts-loader', }, '*.svg': { loader: 'svg-loader', }, 'devextreme/time_zone_utils.js': { 'esModule': true, }, 'devextreme/localization.js': { 'esModule': true, }, 'devextreme/viz/palette.js': { 'esModule': true, }, 'devextreme-dist/js/vectormap-data/*': { 'esModule': true, }, 'openai': { 'esModule': true, }, }, paths: { 'project:': '../../../../', 'npm:': 'https://cdn.jsdelivr.net/npm/', 'bundles:': '../../../../bundles/', 'externals:': '../../../../bundles/externals/', }, map: { 'vue': 'npm:vue@3.4.27/dist/vue.esm-browser.js', '@vue/shared': 'npm:@vue/shared@3.4.27/dist/shared.cjs.prod.js', 'vue-loader': 'npm:dx-systemjs-vue-browser@1.1.2/index.js', 'demo-ts-loader': 'project:utils/demo-ts-loader.js', 'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js', 'svg-loader': 'project:utils/svg-loader.js', 'devextreme-dist/js/vectormap-data': '../../../../js/vectormap-data', 'mitt': 'npm:mitt/dist/mitt.umd.js', 'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js', 'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js', 'es6-object-assign': 'npm:es6-object-assign', 'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs', 'devextreme-vue': 'npm:devextreme-vue@link:../../packages/devextreme-vue/npm/cjs', 'devextreme-quill': 'npm:devextreme-quill@1.7.6/dist/dx-quill.min.js', 'devexpress-diagram': 'npm:devexpress-diagram@2.2.24/dist/dx-diagram.js', 'devexpress-gantt': 'npm:devexpress-gantt@4.1.64/dist/dx-gantt.js', 'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js', 'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js', 'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js', 'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js', 'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js', 'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js', 'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js', 'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js', '@preact/signals-core': 'npm:@preact/signals-core@1.8.0/dist/signals-core.min.js', 'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js', 'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js', // Prettier 'prettier/standalone': 'npm:prettier@2.8.8/standalone.js', 'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js', }, packages: { 'devextreme-vue': { main: 'index.js', }, 'devextreme-vue/common': { main: 'index.js', }, 'devextreme': { defaultExtension: 'js', }, 'devextreme/events/utils': { main: 'index', }, 'devextreme/common/core/events/utils': { main: 'index', }, 'devextreme/events': { main: 'index', }, 'es6-object-assign': { main: './index.js', defaultExtension: 'js', }, }, packageConfigPaths: [ 'npm:@devextreme/*/package.json', ], babelOptions: { sourceMaps: false, stage0: true, }, }; System.config(window.config); // eslint-disable-next-line const useTgzInCSB = ['openai'];
export const markers = [ { coordinates: [-0.1262, 51.5002], attributes: { name: 'London', }, }, { coordinates: [149.1286, -35.2820], attributes: { name: 'Canberra', }, }, { coordinates: [139.6823, 35.6785], attributes: { name: 'Tokyo', }, }, { coordinates: [-77.0241, 38.8921], attributes: { name: 'Washington', }, }, { coordinates: [-75.6794, 45.4214], attributes: { name: 'Ottawa', }, }, { coordinates: [37.617778, 55.751667], attributes: { name: 'Moscow', }, }, { coordinates: [116.4, 39.933333], attributes: { name: 'Beijing', }, }, { coordinates: [12.5, 41.9], attributes: { name: 'Rome', }, }, { coordinates: [23.716667, 38], attributes: { name: 'Athens', }, }, { coordinates: [2.333333, 48.833333], attributes: { name: 'Paris', }, }, { coordinates: [-3.683333, 40.4], attributes: { name: 'Madrid', }, }, { coordinates: [-47.866667, -15.798889], attributes: { name: 'Brasilia', }, }, ];
import { createApp } from 'vue'; import App from './App.vue'; createApp(App).mount('#app');
<!DOCTYPE html> <html lang="en"> <head> <title>DevExtreme Demo</title> <meta http-equiv="X-UA-Compatible" content="IE=edge" /> <meta http-equiv="Content-Type" content="text/html; charset=utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" /> <link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.1.6/css/dx.light.css" /> <script src="https://cdn.jsdelivr.net/npm/typescript@5.4.5/lib/typescript.js"></script> <script type="module"> import * as vueCompilerSFC from "https://cdn.jsdelivr.net/npm/@vue/compiler-sfc@3.4.27/dist/compiler-sfc.esm-browser.js"; window.vueCompilerSFC = vueCompilerSFC; </script> <script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script> <script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script> <script type="text/javascript" src="config.js"></script> <script type="text/javascript"> System.import("./index.ts"); </script> </head> <body class="dx-viewport"> <div class="demo-container"> <div id="app"></div> </div> </body> </html>

DevExtreme v26.1 is now available.

Explore our newest features/capabilities and share your thoughts with us.

Your search did not match any results.

React Vector Map - Zooming and Centering

This demo shows the VectorMap zooming and centering capabilities. The map contains several cities represented by dot markers. To identify a city, pause on its marker, and the name of the city will appear in a tooltip. Moreover, if you click the marker, the map will be zoomed and centered on it. In code it is performed by calling the center(centerCoordinates) and zoomFactor(zoomFactor) methods. A click on the «Reset» button restores default center coordinates and zoom factor.

Backend API
import React, { useCallback, useRef } from 'react'; import VectorMap, { Layer, Tooltip, } from 'devextreme-react/vector-map'; import type { VectorMapTypes, ITooltipProps, VectorMapRef } from 'devextreme-react/vector-map'; import Button from 'devextreme-react/button'; import * as mapsData from 'devextreme-dist/js/vectormap-data/world.js'; import { markers } from './data.ts'; const bounds = [-180, 85, 180, -60]; const customizeTooltip: ITooltipProps['customizeTooltip'] = (arg) => { if (arg.layer.type === 'marker') { return { text: arg.attribute('name') }; } return {}; }; const markerClick = (e: VectorMapTypes.ClickEvent) => { if (e.target?.layer.type === 'marker') { e.component.center(e.target.coordinates()); e.component.zoomFactor(10); } }; const App = () => { const vectorMapRef = useRef<VectorMapRef>(null); const reset = useCallback(() => { vectorMapRef.current?.instance().center([0, 0]); vectorMapRef.current?.instance().zoomFactor(1); }, []); return ( <> <VectorMap ref={vectorMapRef} id="vector-map" onClick={markerClick} bounds={bounds} > <Layer dataSource={mapsData.world} hoverEnabled={false} /> <Layer dataSource={markers} /> <Tooltip enabled={true} customizeTooltip={customizeTooltip} /> </VectorMap> <Button text="Reset" id="reset" onClick={reset} /> </> ); }; export default App;
import React, { useCallback, useRef } from 'react'; import VectorMap, { Layer, Tooltip } from 'devextreme-react/vector-map'; import Button from 'devextreme-react/button'; import * as mapsData from 'devextreme-dist/js/vectormap-data/world.js'; import { markers } from './data.js'; const bounds = [-180, 85, 180, -60]; const customizeTooltip = (arg) => { if (arg.layer.type === 'marker') { return { text: arg.attribute('name') }; } return {}; }; const markerClick = (e) => { if (e.target?.layer.type === 'marker') { e.component.center(e.target.coordinates()); e.component.zoomFactor(10); } }; const App = () => { const vectorMapRef = useRef(null); const reset = useCallback(() => { vectorMapRef.current?.instance().center([0, 0]); vectorMapRef.current?.instance().zoomFactor(1); }, []); return ( <> <VectorMap ref={vectorMapRef} id="vector-map" onClick={markerClick} bounds={bounds} > <Layer dataSource={mapsData.world} hoverEnabled={false} /> <Layer dataSource={markers} /> <Tooltip enabled={true} customizeTooltip={customizeTooltip} /> </VectorMap> <Button text="Reset" id="reset" onClick={reset} /> </> ); }; export default App;
import React from 'react'; import ReactDOM from 'react-dom'; import App from './App.tsx'; ReactDOM.render( <App />, document.getElementById('app'), );
export const markers = [ { coordinates: [-0.1262, 51.5002], attributes: { name: 'London', }, }, { coordinates: [149.1286, -35.2820], attributes: { name: 'Canberra', }, }, { coordinates: [139.6823, 35.6785], attributes: { name: 'Tokyo', }, }, { coordinates: [-77.0241, 38.8921], attributes: { name: 'Washington', }, }, { coordinates: [-75.6794, 45.4214], attributes: { name: 'Ottawa', }, }, { coordinates: [37.617778, 55.751667], attributes: { name: 'Moscow', }, }, { coordinates: [116.4, 39.933333], attributes: { name: 'Beijing', }, }, { coordinates: [12.5, 41.9], attributes: { name: 'Rome', }, }, { coordinates: [23.716667, 38], attributes: { name: 'Athens', }, }, { coordinates: [2.333333, 48.833333], attributes: { name: 'Paris', }, }, { coordinates: [-3.683333, 40.4], attributes: { name: 'Madrid', }, }, { coordinates: [-47.866667, -15.798889], attributes: { name: 'Brasilia', }, }, ];
declare module 'devextreme-dist/js/vectormap-data/world.js' { type Position = number[]; type Geometry = | { type: 'Point'; coordinates: Position } | { type: 'MultiPoint'; coordinates: Position[] } | { type: 'LineString'; coordinates: Position[] } | { type: 'MultiLineString'; coordinates: Position[][] } | { type: 'Polygon'; coordinates: Position[][] } | { type: 'MultiPolygon'; coordinates: Position[][][] }; interface Feature { type: 'Feature'; geometry: Geometry; properties: Record<string, unknown>; } interface FeatureCollection { type: 'FeatureCollection'; features: Feature[]; // eslint-disable-next-line spellcheck/spell-checker bbox?: number[]; } const world: FeatureCollection; export { world }; export default world; }
window.exports = window.exports || {}; window.config = { transpiler: false, meta: { '*.ts': { loader: 'demo-ts-loader', }, '*.tsx': { loader: 'demo-ts-loader', typescriptOptions: { jsx: 'react', }, }, 'typescript': { 'exports': 'ts', }, 'anti-forgery': { loader: 'demo-ts-loader', }, 'react': { 'esModule': true, }, 'devextreme/time_zone_utils.js': { 'esModule': true, }, 'devextreme/localization.js': { 'esModule': true, }, 'devextreme/viz/palette.js': { 'esModule': true, }, 'devextreme-dist/js/vectormap-data/*': { 'esModule': true, }, 'openai': { 'esModule': true, }, 'zod': { 'esModule': true, }, 'zod-to-json-schema': { 'esModule': true, }, }, paths: { 'project:': '../../../../', 'npm:': 'https://cdn.jsdelivr.net/npm/', 'bundles:': '../../../../bundles/', 'externals:': '../../../../bundles/externals/', 'anti-forgery:': '../../../../shared/anti-forgery/', }, defaultExtension: 'js', map: { 'anti-forgery': 'anti-forgery:fetch-override.js', 'demo-ts-loader': 'project:utils/demo-ts-loader.js', 'demo-ts-shared': 'project:utils/demo-ts-shared.js', 'typescript': 'npm:typescript@4.2.4/lib/typescript.js', 'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js', 'react': 'npm:react@17.0.2/umd/react.development.js', 'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js', 'prop-types': 'npm:prop-types/prop-types.js', 'devextreme-dist/js/vectormap-data': '../../../../js/vectormap-data', 'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js', 'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js', 'es6-object-assign': 'npm:es6-object-assign', 'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs', 'devextreme-react': 'npm:devextreme-react@link:../../packages/devextreme-react/npm/cjs', 'zod': 'externals:zod.bundle.js', 'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js', 'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js', 'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js', 'devexpress-gantt': 'npm:devexpress-gantt@4.1.69/dist/dx-gantt.js', 'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js', 'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js', 'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js', 'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js', 'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js', 'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js', 'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js', 'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js', '@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js', 'devextreme-cldr-data': 'npm:devextreme-cldr-data@1.0.3', // Prettier 'prettier/standalone': 'npm:prettier@2.8.8/standalone.js', 'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js', }, packages: { 'devextreme': { defaultExtension: 'js', }, 'devextreme-react': { main: 'index.js', }, 'devextreme-react/common': { main: 'index.js', }, 'devextreme/events/utils': { main: 'index', }, 'devextreme/common/core/events/utils': { main: 'index', }, 'devextreme/localization/messages': { format: 'json', defaultExtension: 'json', }, 'devextreme/events': { main: 'index', }, 'es6-object-assign': { main: './index.js', defaultExtension: 'js', }, }, packageConfigPaths: [ 'npm:@devextreme/*/package.json', ], }; window.process = { env: { NODE_ENV: 'production', }, }; System.config(window.config); // eslint-disable-next-line const useTgzInCSB = ['openai']; let packagesInfo = { "zod": { "version": "3.24.4" }, "zod-to-json-schema": { "version": "3.24.6" } };
import React from 'react'; import ReactDOM from 'react-dom'; import App from './App.js'; ReactDOM.render(<App />, document.getElementById('app'));
export const markers = [ { coordinates: [-0.1262, 51.5002], attributes: { name: 'London', }, }, { coordinates: [149.1286, -35.282], attributes: { name: 'Canberra', }, }, { coordinates: [139.6823, 35.6785], attributes: { name: 'Tokyo', }, }, { coordinates: [-77.0241, 38.8921], attributes: { name: 'Washington', }, }, { coordinates: [-75.6794, 45.4214], attributes: { name: 'Ottawa', }, }, { coordinates: [37.617778, 55.751667], attributes: { name: 'Moscow', }, }, { coordinates: [116.4, 39.933333], attributes: { name: 'Beijing', }, }, { coordinates: [12.5, 41.9], attributes: { name: 'Rome', }, }, { coordinates: [23.716667, 38], attributes: { name: 'Athens', }, }, { coordinates: [2.333333, 48.833333], attributes: { name: 'Paris', }, }, { coordinates: [-3.683333, 40.4], attributes: { name: 'Madrid', }, }, { coordinates: [-47.866667, -15.798889], attributes: { name: 'Brasilia', }, }, ];
<!DOCTYPE html> <html lang="en"> <head> <title>DevExtreme Demo</title> <meta http-equiv="X-UA-Compatible" content="IE=edge" /> <meta http-equiv="Content-Type" content="text/html; charset=utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" /> <link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.3/css/dx.light.css" /> <link rel="stylesheet" type="text/css" href="styles.css" /> <script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script> <script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script> <script type="text/javascript" src="config.js"></script> <script type="text/javascript"> System.import("./index.tsx"); </script> </head> <body class="dx-viewport"> <div class="demo-container"> <div id="app"></div> </div> </body> </html>
#vector-map { height: 420px; } #reset { margin: 10px 2px; }